/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* Generated By:JavaCC: Do not edit this line. TableSchemaParser.java */
package org.apache.hadoop.zebra.types;
import java.io.*;

public class TableSchemaParser implements TableSchemaParserConstants {
           public static void main( String[] args )
           throws ParseException, TokenMgrError , java.io.FileNotFoundException, java.io.IOException {
                TableSchemaParser parser = new TableSchemaParser( System.in ) ;
                                        Schema schema = parser.RecordSchema(null);
                                        System.out.println("OK");
                                        FileOutputStream output = new FileOutputStream("/tmp/schema");
                                        ObjectOutputStream objout = new ObjectOutputStream(output);
                                        objout.writeObject(schema);
                                        objout.close();
                                        System.out.println(schema.toString());
      }

  final public ColumnType Type() throws ParseException {
        ColumnType type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INT:
    case BOOL:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case STRING:
    case BYTES:
      type = BasicType();
      break;
    case COLLECTION:
    case RECORD:
    case MAP:
      type = CompositeType();
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

  final public ColumnType CompositeType() throws ParseException {
        Token t = null;
        ColumnType type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MAP:
      t = jj_consume_token(MAP);
      break;
    case COLLECTION:
      t = jj_consume_token(COLLECTION);
      break;
    case RECORD:
      t = jj_consume_token(RECORD);
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        type = ColumnType.getTypeByName(t.image);
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

  final public ColumnType BasicType() throws ParseException {
        Token t = null;
        ColumnType type;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INT:
      t = jj_consume_token(INT);
      break;
    case LONG:
      t = jj_consume_token(LONG);
      break;
    case FLOAT:
      t = jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      t = jj_consume_token(DOUBLE);
      break;
    case STRING:
      t = jj_consume_token(STRING);
      break;
    case BYTES:
      t = jj_consume_token(BYTES);
      break;
    case BOOL:
      t = jj_consume_token(BOOL);
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   String typeName = t.image;
        type = ColumnType.getTypeByName(typeName);
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema ColumnSchema() throws ParseException, ParseException {
        Token t1;
        Schema item = null;
        Schema.ColumnSchema fs = null;
    if (jj_2_1(2147483647)) {
      fs = SchemaRecord();
    } else if (jj_2_2(2147483647)) {
      fs = SchemaCollection();
    } else if (jj_2_3(2147483647)) {
      fs = SchemaMap();
    } else {
      fs = AtomSchema();
    }
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AtomSchema() throws ParseException, ParseException {
        Token t1 = null;
        ColumnType type = ColumnType.BYTES;
        Schema.ColumnSchema fs;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      t1 = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 21:
        jj_consume_token(21);
        type = BasicType();
        break;
      default:
        jj_la1[3] = jj_gen;
        ;
      }
                        fs = new Schema.ColumnSchema(t1.image, type);
                        {if (true) return fs;}
      break;
    default:
      jj_la1[4] = jj_gen;
      {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema SchemaMap() throws ParseException, ParseException {
        Token t1 = null;
        Schema s;
        Schema.ColumnSchema fs;
    t1 = jj_consume_token(IDENTIFIER);
    jj_consume_token(21);
    jj_consume_token(MAP);
    s = MapSchema();
                fs = new Schema.ColumnSchema(t1.image, s, ColumnType.MAP);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema SchemaRecord() throws ParseException, ParseException {
        Token t1 = null;
        Schema s;
        Schema.ColumnSchema fs;
    t1 = jj_consume_token(IDENTIFIER);
    jj_consume_token(21);
    jj_consume_token(RECORD);
    jj_consume_token(22);
    s = RecordSchemaInternal(null);
    jj_consume_token(23);
                fs = new Schema.ColumnSchema(t1.image, s, ColumnType.RECORD);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema SchemaCollection() throws ParseException, ParseException {
        Token t1 = null;
        Schema.ColumnSchema fs = null;
    t1 = jj_consume_token(IDENTIFIER);
    jj_consume_token(21);
    jj_consume_token(COLLECTION);
    jj_consume_token(22);
    fs = SchemaCollectionEntry(t1.image);
    jj_consume_token(23);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema SchemaCollectionEntry(String id) throws ParseException, ParseException {
        Schema s = null;
        Schema.ColumnSchema fs = null;
    s = RecordSchemaInternal(null);
          if (s == null) s = new Schema(fs); fs = new Schema.ColumnSchema(id, s, ColumnType.COLLECTION); {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AnonymousColumnSchema() throws ParseException, ParseException {
        Token t1;
        Schema item = null;
        Schema.ColumnSchema fs = null;
    if (jj_2_4(2147483647)) {
      fs = AnonymousSchemaRecord();
    } else if (jj_2_5(2147483647)) {
      fs = AnonymousSchemaCollection();
    } else if (jj_2_6(2147483647)) {
      fs = AnonymousSchemaMap();
    } else {
      fs = AnonymousAtomSchema();
    }
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AnonymousAtomSchema() throws ParseException, ParseException {
        ColumnType type = ColumnType.BYTES;
        Schema.ColumnSchema fs;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INT:
    case BOOL:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case STRING:
    case BYTES:
      type = BasicType();
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
                        fs = new Schema.ColumnSchema(null, type);
                        {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AnonymousSchemaMap() throws ParseException, ParseException {
        Schema s;
        Schema.ColumnSchema fs;
    jj_consume_token(MAP);
    s = MapSchema();
                fs = new Schema.ColumnSchema(null, s, ColumnType.MAP);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AnonymousSchemaRecord() throws ParseException, ParseException {
        Token t1 = null;
        Schema s;
        Schema.ColumnSchema fs;
    jj_consume_token(RECORD);
    jj_consume_token(22);
    s = RecordSchemaInternal(null);
    jj_consume_token(23);
                fs = new Schema.ColumnSchema(null, s, ColumnType.RECORD);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema.ColumnSchema AnonymousSchemaCollection() throws ParseException, ParseException {
        Schema s;
        Schema.ColumnSchema fs;
    jj_consume_token(COLLECTION);
    jj_consume_token(22);
    s = RecordSchemaInternal(null);
    jj_consume_token(23);
                fs = new Schema.ColumnSchema(null, s, ColumnType.COLLECTION);
                {if (true) return fs;}
    throw new Error("Missing return statement in function");
  }

  final public Schema RecordSchemaInternal(Schema list) throws ParseException, ParseException {
        Schema item = null;
        if (list == null)
                list = new Schema();
        Schema.ColumnSchema fs = null;
    fs = ColumnSchema();
                                     list.add(fs);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 24:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_1;
      }
      jj_consume_token(24);
      fs = ColumnSchema();
                                           list.add(fs);
    }
          {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public Schema RecordSchema(Schema list) throws ParseException, ParseException {
        Schema item = null;
        if (list == null)
                list = new Schema();
        Schema.ColumnSchema fs = null;
    fs = ColumnSchema();
                                     list.add(fs);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 24:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_2;
      }
      jj_consume_token(24);
      fs = ColumnSchema();
                                           list.add(fs);
    }
    jj_consume_token(0);
          {if (true) return (list.getNumColumns() == 0 || (list.getNumColumns() == 1 && list.getColumn(0) == null) ? null : list);}
    throw new Error("Missing return statement in function");
  }

  final public Schema MapSchema() throws ParseException, ParseException {
        Schema item = null;
        Schema list = new Schema();
        Schema.ColumnSchema fs = null;
    if (jj_2_7(3)) {
      jj_consume_token(22);
      fs = AnonymousColumnSchema();
      jj_consume_token(23);
    } else {

    }
        if (fs == null)
        {
                list.add(new Schema.ColumnSchema("", ColumnType.BYTES));
        } else {
                list.add(fs);
        }
        {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_3R_18() {
    if (jj_scan_token(24)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  private boolean jj_3R_20() {
    if (jj_3R_9()) return true;
    return false;
  }

  private boolean jj_3R_19() {
    if (jj_3R_10()) return true;
    return false;
  }

  private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_19()) {
    jj_scanpos = xsp;
    if (jj_3R_20()) return true;
    }
    return false;
  }

  private boolean jj_3R_29() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(7)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_10() {
    if (jj_3R_17()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_18()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_4() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(21)) return true;
    if (jj_scan_token(COLLECTION)) return true;
    if (jj_scan_token(22)) return true;
    if (jj_3R_11()) return true;
    if (jj_scan_token(23)) return true;
    return false;
  }

  private boolean jj_3R_7() {
    if (jj_scan_token(COLLECTION)) return true;
    if (jj_scan_token(22)) return true;
    if (jj_3R_10()) return true;
    if (jj_scan_token(23)) return true;
    return false;
  }

  private boolean jj_3R_3() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(21)) return true;
    if (jj_scan_token(RECORD)) return true;
    if (jj_scan_token(22)) return true;
    if (jj_3R_10()) return true;
    if (jj_scan_token(23)) return true;
    return false;
  }

  private boolean jj_3R_32() {
    if (jj_scan_token(21)) return true;
    if (jj_3R_29()) return true;
    return false;
  }

  private boolean jj_3R_6() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_scan_token(22)) return true;
    if (jj_3R_10()) return true;
    if (jj_scan_token(23)) return true;
    return false;
  }

  private boolean jj_3R_5() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(21)) return true;
    if (jj_scan_token(MAP)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  private boolean jj_3R_8() {
    if (jj_scan_token(MAP)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  private boolean jj_3R_30() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_32()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_31() {
    return false;
  }

  private boolean jj_3R_27() {
    if (jj_3R_29()) return true;
    return false;
  }

  private boolean jj_3R_28() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) return true;
    }
    return false;
  }

  private boolean jj_3_3() {
    if (jj_3R_5()) return true;
    return false;
  }

  private boolean jj_3R_22() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_27()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_4()) return true;
    return false;
  }

  private boolean jj_3R_21() {
    return false;
  }

  private boolean jj_3_1() {
    if (jj_3R_3()) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_3R_8()) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_3R_7()) return true;
    return false;
  }

  private boolean jj_3_7() {
    if (jj_scan_token(22)) return true;
    if (jj_3R_9()) return true;
    if (jj_scan_token(23)) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_6()) return true;
    return false;
  }

  private boolean jj_3R_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) return true;
    }
    return false;
  }

  private boolean jj_3R_26() {
    if (jj_3R_28()) return true;
    return false;
  }

  private boolean jj_3R_25() {
    if (jj_3R_5()) return true;
    return false;
  }

  private boolean jj_3R_24() {
    if (jj_3R_4()) return true;
    return false;
  }

  private boolean jj_3R_23() {
    if (jj_3R_3()) return true;
    return false;
  }

  private boolean jj_3R_17() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3R_16() {
    if (jj_3R_22()) return true;
    return false;
  }

  private boolean jj_3R_15() {
    if (jj_3R_8()) return true;
    return false;
  }

  private boolean jj_3R_14() {
    if (jj_3R_7()) return true;
    return false;
  }

  private boolean jj_3R_13() {
    if (jj_3R_6()) return true;
    return false;
  }

  private boolean jj_3R_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_13()) {
    jj_scanpos = xsp;
    if (jj_3R_14()) {
    jj_scanpos = xsp;
    if (jj_3R_15()) {
    jj_scanpos = xsp;
    if (jj_3R_16()) return true;
    }
    }
    }
    return false;
  }

  /** Generated Token Manager. */
  public TableSchemaParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[8];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x1ff80,0x1c000,0x3f80,0x200000,0x100000,0x3f80,0x1000000,0x1000000,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[7];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public TableSchemaParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public TableSchemaParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new TableSchemaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public TableSchemaParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new TableSchemaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public TableSchemaParser(TableSchemaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(TableSchemaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 8; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List jj_expentries = new java.util.ArrayList();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[25];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 8; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 25; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 7; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
